/* Copyright © 2020 tyrolyean
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _STRUCTURES_H
#define _STRUCTURES_H

#include <stdint.h>
#include <avr/pgmspace.h>
#include <stdbool.h>

#define NUM_ACTIONS      0x07
#define ACTION_HELP      0x00
#define ACTION_NORTH     0x01
#define ACTION_SOUTH     0x02
#define ACTION_WEST      0x03
#define ACTION_EAST      0x04
#define ACTION_DESCRIBE  0x05
#define ACTION_USE       0x06

extern const uint8_t sine_table[256] PROGMEM;
extern const uint8_t noise_table[1024] PROGMEM;
extern const char* text_table[];

extern const char* info_table[];
extern const char* action_table[NUM_ACTIONS];
extern const char* room_table[];
extern const char* room_description_table[];
extern const bool room_action_table[][NUM_ACTIONS];
extern const char* item_table[];

#endif
